<template>
  <v-row>
    <v-col cols="12">
      <v-card class="pa-3" elevation="10">
        <v-card-text>
          <div class="d-flex align-center">
            <div>
              <h3 class="text-h5 title">This week's analytics overview</h3>
            </div>
            <div class="ml-auto">
              <div class="d-flex align-center">
                <div class="d-flex align-center mr-2">
                  <div><v-btn variant="text" class="mdi mdi-poll bg-success2" size="30"></v-btn></div>
                </div>
                <div class="d-flex align-center ">
                  <div><v-btn variant="text" class="mdi mdi-chart-line success2" size="30"></v-btn></div>
                </div>
              </div>
            </div>
          </div>
          <!-- การเรียกใช้ตารางแสดงแผนภูมิแท่งแบบมีเงื่อนไขโดยใช้ ApexCharts -->
          <div v-show="elementVisible" class="mt-1">
            <apexchart
              type="bar"
              height="280"
              :options="chartOptions"
              :series="Chart.series"
            ></apexchart>
          </div>
        </v-card-text>
      </v-card>
    </v-col>
  </v-row>
</template>

<script setup lang="ts">
import { ref, onMounted, computed } from "vue";
/*Chart*/
// ตัวแปร chartOptions ที่ได้จากการคำนวณมีการกำหนดค่าเพื่อปรับแต่งลักษณะและพฤติกรรมของกราฟแท่ง
const chartOptions = computed(() => {
  // ตัวเลือกการกำหนดค่าสำหรับไลบรารี ApexCharts
  return {
    grid: {
      show: false, // ซ่อนเส้นกริด
      borderColor: "transparent", // สีของเส้นกริดที่โปร่งใส
      padding: { left: 0, right: 0, bottom: 0 }, // กำหนดระยะขอบสำหรับเส้นกริด
    },
    plotOptions: {
      bar: { horizontal: false, columnWidth: "35%", borderRadius: 0 }, // ตัวเลือกของกราฟแท่ง
    },
    colors: ["#5DB3A8", "#FD8785"], // สีของ series
    fill: { type: "solid", opacity: 1 }, // การเติมสี solid ให้แกน
    chart: {
      type: "bar", // ประเภทของกราฟคือแท่ง
      height: 320, // ความสูงของกราฟ
      offsetX: -15, // การกำหนดระยะห่างเพื่อให้มองเห็นได้ชัดเจน
      toolbar: { show: false }, // ซ่อนเครื่องมือของกราฟ
      foreColor: "#adb0bb", // สีของข้อความหน้าปัด
      fontFamily: "Poppins", // แบบอักษรของข้อความ
      sparkline: { enabled: false }, // ปิดใช้งานโหมด Sparkline
    },
    dataLabels: { enabled: false }, // ปิดใช้งาน Data Labels
    markers: { size: 0 }, // กำหนดขนาดของ Markers เป็น 0
    legend: { show: false }, // ซ่อนคำอธิบาย
    xaxis: {
      type: "category", // ประเภทของแกน X เป็น category
      categories: ["Mon", "Tue", "Wed", "Thu", "Fri", "Sat", "Sun"], // รายชื่อของวัน
      labels: {
        style: { cssClass: "grey--text lighten-2--text fill-color" }, // การจัดรูปแบบข้อความของแกน X
      },
    },
    yaxis: {
      show: true, // แสดงแกน Y
      min: 0, // ค่าต่ำสุดของแกน Y
      max: 25, // ค่าสูงสุดของแกน Y
      tickAmount: 3, // จำนวนของทิกบนแกน Y
      labels: {
        style: {
          cssClass: "grey--text lighten-2--text fill-color", // การจัดรูปแบบข้อความของแกน Y
        },
      },
    },
    stroke: {
      show: true, // แสดงเส้นขอบ
      width: 7, // ความกว้างของเส้นขอบ
      lineCap: "butt", // สไตล์ของปลายเส้น
      colors: ["transparent"], // สีของเส้นขอบที่โปร่งใส
    },
    tooltip: { theme: "dark" }, // ธีมของ tooltip เป็นสีเข้ม
  };
});


const Chart = {
  series: [
    { name: "health", data: [20, 20, 20, 20, 20, 20, 20] },
    { name: "continue_treatment", data: [10, 13, 7, 15, 10, 8, 14] },
  ],
};

const elementVisible = ref(false);
onMounted(() => {
  setTimeout(() => (elementVisible.value = true), 10);
});
</script>